using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.Threading;

namespace II320_SampleCS
{
    public partial class FormMain : Form
    {
        const int _MAX_DIO_BIT = 32;
        Color _DI_ON_COLOR = Color.FromArgb(0xFF, 0x80, 0xFF);
        Color _DI_OFF_COLOR = Color.FromArgb(0x80, 0x80, 0x80);
        Color _DO_ON_COLOR = Color.FromArgb(0x00, 0xFF, 0xFF);
        Color _DO_OFF_COLOR = Color.FromArgb(0x80, 0x80, 0x80);
        Color _INT_ON_COLOR = Color.FromArgb(0xFF, 0x80, 0xFF);
        Color _INT_OFF_COLOR = Color.FromArgb(0xC0, 0xC0, 0xC0);
        const string _DI_ON_TEXT = "ON";
        const string _DI_OFF_TEXT = "OFF";
        const string _DO_ON_TEXT = "ON";
        const string _DO_OFF_TEXT = "OFF";

        public FVIL.Dio.CFviDioII320 m_dio = new FVIL.Dio.CFviDioII320();
        public Label[] m_di = new Label[_MAX_DIO_BIT];
        public Label[] m_do = new Label[_MAX_DIO_BIT];

        public FVIL.Dio.CFviWaitEventParam m_wait_event_param = new FVIL.Dio.CFviWaitEventParam();
        public Thread m_thread;

        public FormMain()
        {
            InitializeComponent();
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            // Rg[̔z
            for (int i = 0; i < _MAX_DIO_BIT; i++)
            {
                string fieldname_di = string.Format("labelDI{0:d2}", i);
                this.m_di[i] = (Label)this.GetType().GetField(fieldname_di,BindingFlags.Public|BindingFlags.NonPublic|BindingFlags.Instance|BindingFlags.DeclaredOnly).GetValue(this);

                string fieldname_do = string.Format("labelDO{0:d2}", i);
                this.m_do[i] = (Label)this.GetType().GetField(fieldname_do,BindingFlags.Public|BindingFlags.NonPublic|BindingFlags.Instance|BindingFlags.DeclaredOnly).GetValue(this);
            }
            // DO{^CLICKCxgǉ
            foreach (Label lb in m_do)
                lb.Click += new EventHandler(DO_Button_Click);

            this.Show();

            // WIL
            FVIL._SetUp.InitVisionLibrary();

            FormOpen form_open = new FormOpen();
            if (DialogResult.OK == form_open.ShowDialog(this))
            {
                try
                {
                    m_dio.Open(form_open.get_device_id());

                }
                catch (FVIL.CFviException ex)
                {
                    MessageBox.Show(ex.Function + ", ErrorCode:" + ex.ErrorCode.ToString(), "error");
                    System.Environment.Exit(0);
                }
            }
            else
                System.Environment.Exit(0);
            try
            {
                // Ԃ̎擾
                _disp_di(m_dio.Read());
                _disp_do(m_dio.GetWrite());
            }
            catch (FVIL.CFviException ex)
            {
                MessageBox.Show(ex.Function + ", ErrorCode:" + ex.ErrorCode.ToString(), "error");
            }

            // 荞ݐݒ̏lAWaitEventParamɏlRs[
            m_wait_event_param.DiIntEnable = m_dio.InterruptCtrlDi.Enable;
            m_wait_event_param.IntEnable = m_dio.InterruptCtrlInt.Enable;

            // Read^C}[̃X^[g
            timerRead.Enabled = true;

            m_wait_event_param.Timeout = 0xFFFFFFFF;
        }

        private void DO_Button_Click(object sender, EventArgs e)
        {
            uint no = 0xFFFFFFFF;
            for( int i=0; i<m_do.Length; i++ )
            {
                if (m_do[i].Equals(sender))
                {
                    no = (uint)i;
                    break;
                }
            }
            if (no!=0xFFFFFFFF)
            {
                bool now_data = m_dio.GetWriteBit(no);
                m_dio.WriteBit(no, !now_data);
                _disp_do((int)no, !now_data);
            }
        }


        private void _disp_di(System.Collections.BitArray bit_array)
        {
            if (bit_array.Count != _MAX_DIO_BIT) return;
            for (int i = 0; i < _MAX_DIO_BIT; i++)
                _disp_di(i, bit_array[i]);
        }

        private void _disp_di(int bit, bool value)
        {
            if (bit >= _MAX_DIO_BIT) return;
            m_di[bit].BackColor = value ? _DI_ON_COLOR : _DI_OFF_COLOR;
            m_di[bit].Text = value ? _DI_ON_TEXT : _DI_OFF_TEXT;
        }

        private void _disp_do(System.Collections.BitArray bit_array)
        {
            if (bit_array.Count != _MAX_DIO_BIT) return;
            for (int i = 0; i < _MAX_DIO_BIT; i++)
                _disp_do(i, bit_array[i]);
        }

        private void _disp_do(int bit, bool value)
        {
            if (bit >= _MAX_DIO_BIT) return;
            m_do[bit].BackColor = value ? _DO_ON_COLOR : _DO_OFF_COLOR;
            m_do[bit].Text = value ? _DO_ON_TEXT : _DO_OFF_TEXT;
        }

        private void timerRead_Tick(object sender, EventArgs e)
        {
            _disp_di(m_dio.Read());
        }

        private void buttonInterruptSetting_Click(object sender, EventArgs e)
        {
            if (true == checkBoxCheckInterrupt.Checked)
            {
                m_dio.Abort();
                checkBoxCheckInterrupt.Checked = false;
            }

            FormIntSetting frm = new FormIntSetting();

            frm.di_enable = m_dio.InterruptCtrlDi.Enable;
            frm.di_edge = m_dio.InterruptCtrlDi.Edge;
            frm.int_enable = m_dio.InterruptCtrlInt.Enable;
            frm.int_edge = m_dio.InterruptCtrlInt.Edge;
            frm.wait_event_di_enable = m_wait_event_param.DiIntEnable;
            frm.wait_event_int_enable = m_wait_event_param.IntEnable;
            frm.di_int_mode = m_wait_event_param.DiIntMode;

            if (DialogResult.OK == frm.ShowDialog(this))
            {
                FVIL.Dio.CFviInterruptCtrl _ctrl = new FVIL.Dio.CFviInterruptCtrl();

                _ctrl.Enable = frm.di_enable;
                _ctrl.Edge = frm.di_edge;
                m_dio.InterruptCtrlDi = _ctrl;

                _ctrl.Enable = frm.int_enable;
                _ctrl.Enable = frm.int_edge;
                m_dio.InterruptCtrlInt = _ctrl;

                m_wait_event_param.DiIntEnable = frm.wait_event_di_enable;
                m_wait_event_param.IntEnable = frm.wait_event_int_enable;
                m_wait_event_param.DiIntMode = frm.di_int_mode;
            }
        }

        delegate void DeleSetIntText(uint int_di, Color col);
        void SetIntText(uint int_di, Color col)
        {
            textBoxInterrupt.Text = string.Format("0x{0:x8}",int_di);
            textBoxInterrupt.BackColor = col;
        }

        private void IntThreadRun()
        {
            System.Diagnostics.Debug.Print("IntThreadRun\r\n");

            FVIL.Dio.CFviWaitEventInfo info;
            DeleSetIntText dele = SetIntText;
            while (true)
            {
                try
                {
                    System.Diagnostics.Debug.Print("WaitEvent IN\r\n");
                    info = m_dio.WaitEvent(m_wait_event_param);
                    System.Diagnostics.Debug.Print("WaitEvent Out\r\n");
                    Invoke(dele, info.DI, _INT_ON_COLOR);
                    System.Threading.Thread.Sleep(200);
                    Invoke(dele, info.DI, _INT_OFF_COLOR);
                }
                catch (FVIL.CFviException ex)
                {
                    System.Diagnostics.Debug.Print("Exception ex.errorcoee={0}\r\n", ex.ErrorCode);
                    if (FVIL.Dio.ErrorCode.ABORT != ex.ErrorCode)
                        MessageBox.Show(ex.Function + ", ErrorCode:" + ex.ErrorCode.ToString());
                    break;
                }
            }
        }

        private void checkBoxCheckInterrupt_CheckedChanged(object sender, EventArgs e)
        {
            if (true == checkBoxCheckInterrupt.Checked)
            {
                // Xbh
                m_thread = new Thread(new ThreadStart(IntThreadRun));
                // Thread̃X^[g
                m_thread.Start();
            }
            else
            {
                m_dio.Abort();
            }
        }

        private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            m_dio.Abort();
            System.Threading.Thread.Sleep(200);
        }

        private void buttonNoiseFilterSetting_Click(object sender, EventArgs e)
        {
            FormNoiseFilterSetting dlg = new FormNoiseFilterSetting();
            dlg.m_int_width = (int)m_dio.NoiseFilterInt.Width;
            dlg.m_int_scale = (int)m_dio.NoiseFilterInt.Scale;
            dlg.m_di_width = (int)m_dio.NoiseFilterDi.Width;
            dlg.m_di_scale = (int)m_dio.NoiseFilterDi.Scale;
            if (DialogResult.OK == dlg.ShowDialog(this))
            {
                m_dio.NoiseFilterInt = new FVIL.Dio.CFviNoiseFilterCtrl((uint)dlg.m_int_width, (uint)dlg.m_int_scale);
                m_dio.NoiseFilterDi = new FVIL.Dio.CFviNoiseFilterCtrl((uint)dlg.m_di_width, (uint)dlg.m_di_scale);
            }
        }
    }
}